; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    start_thread PROTO :DWORD, :DWORD
    wait_thread  PROTO :DWORD

    THREAD_ARGUMENTS STRUCT
      flag  dd ?                    ; thread start flag
      tcnt  dd ?                    ; thread termination counter
      thcn  dd ?                    ; started thread count
      signal1 dd ?
      signal2 dd ?
      arg1  dd ?
      arg2  dd ?
      arg3  dd ?
      arg4  dd ?
    THREAD_ARGUMENTS ENDS

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL targs     :THREAD_ARGUMENTS
    LOCAL thread1   :DWORD
    LOCAL thread2   :DWORD
    LOCAL thread3   :DWORD
    LOCAL thread4   :DWORD

    LOCAL thread5   :DWORD
    LOCAL thread6   :DWORD
    LOCAL thread7   :DWORD
    LOCAL thread8   :DWORD

    SetConsoleCaption "Press 1 to RUN threads, 2 to CLOSE threads"

  ; -----------------------------------
  ; load the THREAD_ARGUMENTS structure
  ; -----------------------------------
    mov targs.tcnt, 0                       ; zero the thread counter
    mov targs.arg1, 0
    mov targs.arg2, 8
    mov targs.arg3, 7
    mov targs.arg4, 6

    mov targs.signal1, 0
    mov targs.signal2, 0

    mov targs.thcn, 8                       ; set the thread count to start

  ; -----------------
  ; start the threads
  ; -----------------
    mov thread1, rv(start_thread,ADDR wait_thread,ADDR targs)
    mov thread2, rv(start_thread,ADDR wait_thread,ADDR targs)
    mov thread3, rv(start_thread,ADDR wait_thread,ADDR targs)
    mov thread4, rv(start_thread,ADDR wait_thread,ADDR targs)

    mov thread5, rv(start_thread,ADDR wait_thread,ADDR targs)
    mov thread6, rv(start_thread,ADDR wait_thread,ADDR targs)
    mov thread7, rv(start_thread,ADDR wait_thread,ADDR targs)
    mov thread8, rv(start_thread,ADDR wait_thread,ADDR targs)

  keyloop:
    getkey
    switch eax
      case "1"                              ; RUN the threads
        mov DWORD PTR targs.signal1, 1
        invoke SleepEx,1,0                  ; yield in an idle loop
        jmp keyloop
      case "2"
        mov DWORD PTR targs.signal1, 2      ; CLOSE the threads
        jmp loopexit
      default
        jmp keyloop
    endsw

  loopexit:

  ; ---------------------------------
  ; idle until all threads have ended
  ; ---------------------------------
  @@:
    invoke SleepEx,0,0
    mov eax, targs.thcn
    cmp DWORD PTR targs.tcnt, eax      ; check terminated thread count
    jne @B

  ; ------------------------
  ; close the thread handles
  ; ------------------------
    invoke CloseHandle,thread1
    invoke CloseHandle,thread2
    invoke CloseHandle,thread3
    invoke CloseHandle,thread4

    invoke CloseHandle,thread5
    invoke CloseHandle,thread6
    invoke CloseHandle,thread7
    invoke CloseHandle,thread8


    ret

main endp

; 

start_thread proc pproc:DWORD,pstruct:DWORD

    LOCAL tID       :DWORD
    LOCAL hThread   :DWORD

    push esi

    mov esi, pstruct
    add (THREAD_ARGUMENTS PTR [esi]).arg1, 1

    mov (THREAD_ARGUMENTS PTR [esi]).flag, 1    ; set the flag
    mov hThread, rv(CreateThread,NULL,NULL,pproc,pstruct,NULL,ADDR tID)

  spinlock:
    cmp (THREAD_ARGUMENTS PTR [esi]).flag, 0    ; loop until called thread clears the flag
    jne spinlock

    mov eax, hThread
    mov ecx, tID
    pop esi

    ret

start_thread endp

; 

wait_thread proc pstruct:DWORD

    LOCAL arg1  :DWORD
    LOCAL arg2  :DWORD
    LOCAL arg3  :DWORD
    LOCAL arg4  :DWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[128]:BYTE

    push esi

  ; ---------------------------------------------------------
  ; load the args to locals before the caller flag is cleared
  ; ---------------------------------------------------------
    mov esi, pstruct
    m2m arg1, (THREAD_ARGUMENTS PTR [esi]).arg1
    m2m arg2, (THREAD_ARGUMENTS PTR [esi]).arg2
    m2m arg3, (THREAD_ARGUMENTS PTR [esi]).arg3
    m2m arg4, (THREAD_ARGUMENTS PTR [esi]).arg4

    mov (THREAD_ARGUMENTS PTR [esi]).flag, 0            ; clear the flag

    mov pbuf, ptr$(buffer)
    mov pbuf, cat$(pbuf,"*** Started thread ",str$(arg1),chr$(13,10))

    print pbuf

    jmp idleloop

  ; 
  ; syncloop prevents each thread from restarting until the rest have started
  ; 

  syncloop:
    add (THREAD_ARGUMENTS PTR [esi]).signal2, 1         ; increment the thread run counter

  @@:
    mov eax, (THREAD_ARGUMENTS PTR [esi]).thcn
    cmp (THREAD_ARGUMENTS PTR [esi]).signal2, eax
    invoke SleepEx,1,0                                  ; yield in sync loop
    jne @B

    mov (THREAD_ARGUMENTS PTR [esi]).signal2, 0         ; reset the signal
    mov (THREAD_ARGUMENTS PTR [esi]).signal1, 0         ; reset to 0 after thread has run

    mov pbuf, ptr$(buffer)
    mov pbuf, cat$(pbuf,"### Exiting wait loop ",str$(arg1)," ###",chr$(13,10))
    print pbuf

  ; 
  ; idleloop sits waiting for a start signal > 0
  ; 

  idleloop:
    switch (THREAD_ARGUMENTS PTR [esi]).signal1
      case 0
        invoke SleepEx,1,0                              ; yield in idle loop
        jmp idleloop
      case 1
      ; ---------------------------------------------------------------------
      ; ----------- The ACTION that the thread will take is here ------------
      ; ---------------------------------------------------------------------

        mov pbuf, ptr$(buffer)
        mov pbuf, cat$(pbuf,"+++ Running thread ",str$(arg1)," +++",chr$(13,10))
        print pbuf

        mov eax, 1000000000
      @@:
        rol eax, 8
        rol eax, 8      ; slow the test down
        rol eax, 8
        rol eax, 8
        sub eax, 1
        jnz @B


      ; ---------------------------------------------------------------------
      ; ---------------------------------------------------------------------
      ; ---------------------------------------------------------------------
        jmp syncloop
      case 2
        mov pbuf, ptr$(buffer)
        mov pbuf, cat$(pbuf,"--- Closing thread ",str$(arg1)," ---",chr$(13,10))
        print pbuf

        mov esi, pstruct
        add (THREAD_ARGUMENTS PTR [esi]).tcnt, 1        ; increment the terminated thread counter
        jmp thread_quit
      default
        jmp idleloop
    endsw

  ; 

  thread_quit:
    pop esi
    ret


wait_thread endp

; 

end start
